package com.tzld.piaoquan.recommend.server.service.score.feature;

import com.tzld.piaoquan.recommend.server.common.base.UserFeature;
import com.tzld.piaoquan.recommend.server.common.base.VideoRankFeature;
import com.tzld.piaoquan.recommend.server.common.enums.VlogFeatureGroup;
import com.tzld.piaoquan.recommend.server.gen.recommend.BaseFeature;
import com.tzld.piaoquan.recommend.server.gen.recommend.GroupedFeature;
import com.tzld.piaoquan.recommend.server.gen.recommend.LRSamples;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;
import com.tzld.piaoquan.recommend.server.model.Video;
import com.tzld.piaoquan.recommend.server.service.recall.RecallResult;

import java.util.ArrayList;
import java.util.List;

public class VlogShareFeatureExtractor extends LRFeatureExtractorBase {

    public VlogShareFeatureExtractor() {
        super();
    }
    public VlogShareFeatureExtractor(FeatureUsage usage) {
        super(usage);
    }
    public VlogShareFeatureExtractor(FeatureUsage usage, double userCtrGroup, double videoCtrGroup, int debugLevel) {
        super(usage, userCtrGroup, videoCtrGroup);
    }

    private void getUserFeatures(UserFeature user) {
        makeFea(VlogFeatureGroup.SEX, user.sex);
    }

    private void getContextFeature(RecommendRequest request) {
        makeFea();
    }


    private void getItemFeatures(VideoRankFeature item) {
        makeFea(VlogFeatureGroup.VIDEOID, item.videoid);
    }


    public LRSamples single(RecommendRequest request, UserFeature user, VideoRankFeature itemfeature) {
        features.clear();
        //
        getUserFeatures(user);
        getContextFeature(request);
        getItemFeatures(itemfeature);

        LRSamples.Builder lr =  com.tzld.piaoquan.recommend.server.gen.recommend.LRSamples.newBuilder();
        lr.setGroupNum(groupCount);
        List<com.tzld.piaoquan.recommend.server.gen.recommend.FeatureGroup> keys = new ArrayList<>(features.keySet());
        int count = 0;
        for(com.tzld.piaoquan.recommend.server.gen.recommend.FeatureGroup group : keys) {
            List<BaseFeature> fea = features.get(group);
            GroupedFeature.Builder gf = GroupedFeature.newBuilder();
            gf.setGroup(group);
            gf.setCount(fea.size());
            gf.addAllFeatures(fea);
            count += fea.size();
            lr.addFeatures(gf);
        }
        lr.setCount(count);
        return lr.build();
    }












}
